import os
import time
import socket
import sys
import select

HOST = ''
PORT = 23

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

def main():
    setup_server()
    server()

def setup_server():
    # Allow the reuse of the socket even if stuck in TIME_WAIT
    s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
    #Bind socket to local host and port
    try:
        s.bind((HOST, PORT))
    except socket.error as msg:
        print('Bind failed. Error Code : ' + str(msg[0]) + ' Message ' + msg[1])
        sys.exit()
        
    #Start listening on socket
    s.listen(2)

def server():
    try:
        #now keep talking with the client
        while True:
            #wait to accept a connection - blocking call
            conn, addr = s.accept()

            # Time to wait for incoming data
            conn.settimeout(2)
            # I don't like using try...except for flow control but...
            try:
                while True:
                    data = conn.recv(8)
                    if(len(data) < 0):
                        break;
                    if bytes("crash","utf-8") in data:
                        shutdown_time = 60
                        pause_time = 5
                        while shutdown_time > 0:
                            output_error = "\nInvalid network traffic!\n"
                            output_error += "Shutdown in " + \
                                    str(shutdown_time) + " seconds!\n"
                            os.write(2, bytes(output_error, "UTF-8"))
                            shutdown_time -= pause_time
                            time.sleep(pause_time)
                        os.system("shutdown -r now")
            except socket.timeout as e:
                conn.send(bytes("System running on " + str(conn.getsockname()[0]) + \
                        " you are connecting from " + addr[0] + ".\n", "utf-8"))
                conn.close()
    except KeyboardInterrupt:
        sys.exit()
    except ConnectionResetError:
        conn.close()
        server()
    finally:	
        s.close()
        
main()
